## json-c 0.12.1+ds.1

=== debian/changelog ===
json-c (0.12.1+ds.1-1+dde) unstable; urgency=low

  * ['Autobuild release-candidate: fa78cbe50a6577be0b316f6716c899455124d630']

 -- shuttle <shuttle@deepin.com>  Wed, 02 Sep 2020 17:15:05 +0000

=== debian/control ===
Source: json-c
Priority: optional
Maintainer: Debian QA Group <packages@qa.debian.org>
Build-Depends: debhelper-compat (= 12),
Rules-Requires-Root: no
Standards-Version: 4.3.0
Section: libs
Homepage: https://github.com/json-c/json-c/wiki
Vcs-Git: https://salsa.debian.org/debian/json-c.git
Vcs-Browser: https://salsa.debian.org/debian/json-c

Package: libjson-c3
Architecture: any
Multi-Arch: same
Pre-Depends: ${misc:Pre-Depends}
Depends: ${misc:Depends},
         ${shlibs:Depends}
Description: JSON manipulation library - shared library
 This library allows you to easily construct JSON objects in C,
 output them as JSON formatted strings and parse JSON formatted
 strings back into the C representation of JSON objects.

Package: libjson-c-dev
Section: libdevel
Architecture: any
Multi-Arch: same
Depends: libjson-c3 (= ${binary:Version}),
         ${misc:Depends}
Description: JSON manipulation library - development files
 This library allows you to easily construct JSON objects in C,
 output them as JSON formatted strings and parse JSON formatted
 strings back into the C representation of JSON objects.
 .
 The development headers for compiling programs that use libjson-c
 are provided by this package.

Package: libjson-c-doc
Section: doc
Architecture: all
Multi-Arch: foreign
Depends: libjs-jquery,
         ${misc:Depends}
Description: JSON manipulation library - documentation files
 This library allows you to easily construct JSON objects in C,
 output them as JSON formatted strings and parse JSON formatted
 strings back into the C representation of JSON objects.
 .
 The documentation for libjson-c is provided by this package.

Package: libjson-c3-udeb
Section: debian-installer
Package-Type: udeb
Architecture: any
Pre-Depends: ${misc:Pre-Depends}
Depends: ${misc:Depends},
         ${shlibs:Depends}
Description: JSON manipulation library - shared library (udeb)
 This library allows you to easily construct JSON objects in C,
 output them as JSON formatted strings and parse JSON formatted
 strings back into the C representation of JSON objects.
 .
 This udeb package provides libjson-c3 for the Debian Installer.

=== debian/rules ===
#!/usr/bin/make -f
# See debhelper(7) (uncomment to enable)
# output every command that modifies files on the build system.
#export DH_VERBOSE = 1

# see FEATURE AREAS in dpkg-buildflags(1)
export DEB_BUILD_MAINT_OPTIONS = hardening=+all

# see ENVIRONMENT in dpkg-buildflags(1)
# package maintainers to append CFLAGS
#export DEB_CFLAGS_MAINT_APPEND  = -Wall -pedantic
# package maintainers to append LDFLAGS
export DEB_LDFLAGS_MAINT_APPEND = -Wl,--as-needed

include /usr/share/dpkg/default.mk

DPKG_GENSYMBOLS_CHECK_LEVEL ?= 4

override_dh_auto_clean:
	if test -e Makefile; then \
	    make clean; \
	    for f in Makefile config.h config.log config.status \
	             json.pc json_config.h libtool stamp-h1 stamp-h2 \
	             json-c.pc tests/Makefile; do \
                rm -f $$f; \
	done; \
	fi; \
	if test -d tests/testSubDir; then \
	    rm -R tests/testSubDir; \
	fi

override_dh_missing:
	dh_missing --fail-missing

%:
	dh $@

override_dh_dwz:

override_dh_makeshlibs:
	dh_makeshlibs -V --add-udeb="libjson-c3-udeb"

## json-c 0.12.2+cl4.3.1u4

=== debian/changelog ===
json-c (0.12.2+cl4.3.1u4) RELEASED; urgency=medium

  * new build for 4.3.1 from original hash
    44ff102247ccef067a2e7e5e57aadf8c651c7ca0

 -- root <root@7490f848894d>  Tue, 14 Jun 2022 22:20:09 +0000

json-c (0.12.2+cl4u1) RELEASED; urgency=medium

  * Fixes: crash on failure to generate random seed

 -- dev-support <dev-support@cumulusnetworks.com>  Tue, 27 Oct 2020 09:00:00 -0400

=== debian/control ===
--- 
+++ 
@@ -8,6 +8,9 @@
 Homepage: https://github.com/json-c/json-c/wiki
 Vcs-Git: https://salsa.debian.org/debian/json-c.git
 Vcs-Browser: https://salsa.debian.org/debian/json-c
+XS-Build-Source: True
+XS-Cumulus-Valid-Arch: amd64 armel
+XBCS-Vcs-Hash: 44ff102247ccef067a2e7e5e57aadf8c651c7ca0
 
 Package: libjson-c3
 Architecture: any
@@ -19,6 +22,7 @@
  This library allows you to easily construct JSON objects in C,
  output them as JSON formatted strings and parse JSON formatted
  strings back into the C representation of JSON objects.
+XBCS-Vcs-Hash: 44ff102247ccef067a2e7e5e57aadf8c651c7ca0
 
 Package: libjson-c-dev
 Section: libdevel
@@ -33,6 +37,7 @@
  .
  The development headers for compiling programs that use libjson-c
  are provided by this package.
+XBCS-Vcs-Hash: 44ff102247ccef067a2e7e5e57aadf8c651c7ca0
 
 Package: libjson-c-doc
 Section: doc
@@ -46,6 +51,7 @@
  strings back into the C representation of JSON objects.
  .
  The documentation for libjson-c is provided by this package.
+XBCS-Vcs-Hash: 44ff102247ccef067a2e7e5e57aadf8c651c7ca0
 
 Package: libjson-c3-udeb
 Section: debian-installer
@@ -60,3 +66,5 @@
  strings back into the C representation of JSON objects.
  .
  This udeb package provides libjson-c3 for the Debian Installer.
+XBCS-Vcs-Hash: 44ff102247ccef067a2e7e5e57aadf8c651c7ca0
+

=== debian/rules ===
--- 
+++ 
@@ -9,6 +9,7 @@
 # see ENVIRONMENT in dpkg-buildflags(1)
 # package maintainers to append CFLAGS
 #export DEB_CFLAGS_MAINT_APPEND  = -Wall -pedantic
+export DEB_CFLAGS_MAINT_APPEND = -Wno-error
 # package maintainers to append LDFLAGS
 export DEB_LDFLAGS_MAINT_APPEND = -Wl,--as-needed
 
@@ -35,7 +36,5 @@
 %:
 	dh $@
 
-override_dh_dwz:
-
 override_dh_makeshlibs:
 	dh_makeshlibs -V --add-udeb="libjson-c3-udeb"

## json-c 0.13.1%2Bdfsg

=== debian/changelog ===
json-c (0.13.1+dfsg-7) unstable; urgency=medium

  * QA upload.
  * Rebuild for Ubuntu 20.04 LTS.
  * debian/control: Bump Standards-Version to 4.5.0.

  [ Debian Janitor ]
  * Set upstream metadata fields: Bug-Submit, Repository.

 -- Boyuan Yang <byang@debian.org>  Wed, 19 Feb 2020 10:32:14 -0500

json-c (0.13.1+dfsg-6) unstable; urgency=high

  * QA upload.
  * debian/libjson-c4-dev.links: Fix broken so symlink and make
    everything unified under /usr/lib. (Closes: #941059)

 -- Boyuan Yang <byang@debian.org>  Tue, 24 Sep 2019 10:12:44 -0400

json-c (0.13.1+dfsg-5) unstable; urgency=medium

  * QA upload.
  * debian/libjson-c4.install, debian/libjson-c4-udeb.install:
    Install library files into /usr/lib/ instead of /lib/ to ease
    future usrmerge transition.
  * debian/rules: Use /usr/share/dpkg/architecture.mk instead of
    manually querying DEB_HOST_MULTIARCH.

 -- Boyuan Yang <byang@debian.org>  Mon, 23 Sep 2019 19:31:06 -0400

json-c (0.13.1+dfsg-4) unstable; urgency=medium

  [ Gergely Nagy <algernon@balabit.hu> ]
  * Do not enable valgrind, fails on mips* and is unavailable on most archs
    Closes: #686076
  * QA upload

 -- Gianfranco Costamagna <locutusofborg@debian.org>  Thu, 08 Aug 2019 13:19:56 +0200

json-c (0.13.1+dfsg-3) unstable; urgency=medium

  [ Ondřej Nový ]
  * d/copyright: Use https protocol in Format field

  [ Boyuan Yang ]
  * debian/dch.conf: Use new-style [dch] section instead of [git-dch].
  * debian/control: Mark libjson-c-doc as M-A: foreign.

  [ Gianfranco Costamagna ]
  * Upload to unstable
  * Add doxygen to build-deps
  * Recreate doxygen documentation during build
    - closes: #860871, #722690
    - documentation was already there, so the bugs are fixed since some time
      but recreate the documentation with the doxygen in Debian is preferred.
  * Close old bugs (Closes: #687269, Closes: #780078)
  * Move to compat level 12
  * bump std-version to 4.4.0, no changes required
  * Recreate doxygen documentation
  * Drop old dh_strip migration override
  * Minor fix to copyright file, because lintian can't find the files
  * Drop patch and hack rules file to do the same,
    now html documentation is regenerated during build
  * Enable valgrind tests, they don't fail anymore (Closes: #686076)

 -- Gianfranco Costamagna <locutusofborg@debian.org>  Thu, 08 Aug 2019 12:06:52 +0200

json-c (0.13.1+dfsg-2) experimental; urgency=medium

  * QA upload.
  * Update debian/copyright
    Thanks to Gianfranco Costamagna for the catch.

 -- Nicolas Braud-Santoni <nicolas@braud-santoni.eu>  Tue, 24 Jul 2018 08:32:07 +0200

json-c (0.13.1+dfsg-1) experimental; urgency=medium

  * QA upload.
  * Orphan the package (Closes: 844452)
  * New upstream version (2018-03-05)
    - Remove obsolete patches
    - Bump library SONAME & update symbols file

  * debian/copyright
    - Use the more precise Expat License tag, rather than MIT
    - Drop files that were removed
  * debian/control: Declare compliance with policy v4.1.4
    - Use secure protocol for Vcs-Git URI
    - Replace Priority: extra with optional

  * Switch to debhelper compat level 11
    - Drop autoreconf and autotools-dev dh tools
    - Drop dependency on dh-autoreconf

  * Update debian/watch
  * debian/rules: Enable build-time hardening
  * Repackage to remove a compiled version of jquery.js
  * Lintian overrides
    + Relocate to debian/source/lintian-overrides
    + Add a Lintian override for doc/html/menu.js.
      It is the original source despite containing an oversize line.
    + Remove unused Lintian overrides
  * Patch-out remote images in documentation

 -- Nicolas Braud-Santoni <nicolas@braud-santoni.eu>  Sun, 03 Jun 2018 16:23:43 +0200

## json-c 0.13.1+dfsg

=== debian/changelog ===
json-c (0.13.1+dfsg-7ubuntu0.3) focal-security; urgency=medium

  * SECURITY UPDATE: Integer overflows
    - debian/patches/CVE-2020-12762-*.patch: fix a series of
      integer overflows adding checks in linkhash.c, printbuf.c, test4.c
      test4.expected, also adds the  fix for the INT_MAX regression caused in update
      0.11-4ubuntu2.1.
    - CVE-2020-12762

 -- Leonidas S. Barbosa <leo.barbosa@canonical.com>  Mon, 25 May 2020 14:59:26 -0300

json-c (0.13.1+dfsg-7ubuntu0.2) focal-security; urgency=medium

  * Revert the security fixes and rebuild the old version (LP: #1878723)

 -- Chris Coulson <chris.coulson@canonical.com>  Fri, 15 May 2020 12:31:48 +0100

json-c (0.13.1+dfsg-7ubuntu0.1) focal-security; urgency=medium

  * SECURITY UPDATE: Integer overflows
    - debian/patches/CVE-2020-12762-*.patch: fix a series of
      integer overflows adding checks in arraylist.c,
      linkhash.c, printbuf.c.
    - CVE-2020-12762

 -- Leonidas S. Barbosa <leo.barbosa@canonical.com>  Mon, 11 May 2020 15:44:39 -0300

=== debian/control ===
Source: json-c
Priority: optional
Maintainer: Ubuntu Developers <ubuntu-devel-discuss@lists.ubuntu.com>
XSBC-Original-Maintainer: Debian QA Group <packages@qa.debian.org>
Build-Depends: debhelper-compat (= 12),
               doxygen,
               dh-exec
Standards-Version: 4.5.0
Section: libs
Homepage: https://github.com/json-c/json-c/wiki
Vcs-Git: https://salsa.debian.org/debian/json-c.git
Vcs-Browser: https://salsa.debian.org/debian/json-c

Package: libjson-c4
Architecture: any
Multi-Arch: same
Pre-Depends: ${misc:Pre-Depends}
Depends: ${misc:Depends},
         ${shlibs:Depends}
Description: JSON manipulation library - shared library
 This library allows you to easily construct JSON objects in C,
 output them as JSON formatted strings and parse JSON formatted
 strings back into the C representation of JSON objects.

Package: libjson-c-dev
Section: libdevel
Architecture: any
Multi-Arch: same
Depends: libjson-c4 (= ${binary:Version}),
         ${misc:Depends}
Description: JSON manipulation library - development files
 This library allows you to easily construct JSON objects in C,
 output them as JSON formatted strings and parse JSON formatted
 strings back into the C representation of JSON objects.
 .
 The development headers for compiling programs that use libjson-c
 are provided by this package.

Package: libjson-c-doc
Section: doc
Architecture: all
Multi-Arch: foreign
Depends: libjs-jquery,
         ${misc:Depends}
Description: JSON manipulation library - documentation files
 This library allows you to easily construct JSON objects in C,
 output them as JSON formatted strings and parse JSON formatted
 strings back into the C representation of JSON objects.
 .
 The documentation for libjson-c is provided by this package.

Package: libjson-c4-udeb
Section: debian-installer
Package-Type: udeb
Architecture: any
Pre-Depends: ${misc:Pre-Depends}
Depends: ${misc:Depends},
         ${shlibs:Depends}
Description: JSON manipulation library - shared library (udeb)
 This library allows you to easily construct JSON objects in C,
 output them as JSON formatted strings and parse JSON formatted
 strings back into the C representation of JSON objects.
 .
 This udeb package provides libjson-c4 for the Debian Installer.

=== debian/rules ===
#!/usr/bin/make -f
#export DH_VERBOSE=1

export USE_VALGRIND=0

DPKG_GENSYMBOLS_CHECK_LEVEL ?= 4

export DEB_BUILD_MAINT_OPTIONS = hardening=+all

include /usr/share/dpkg/architecture.mk

%:
	dh $@

override_dh_auto_clean:
	test ! -e Makefile || make clean
	rm -f Makefile config.h config.log config.status \
	      json.pc json_config.h libtool stamp-h1 stamp-h2 \
	      json-c.pc tests/Makefile
	rm -rf tests/testSubDir
	rm -rf doc/html/config_8h.html doc/html/globals_v.html doc/html/jquery.js doc/html/json__config_8h.html
	rm -rf json-c-uninstalled.pc

override_dh_auto_build:
	dh_auto_build
	doxygen Doxyfile
	sed -i '/img src/d' doc/html/index.html

override_dh_missing:
	dh_missing --fail-missing

override_dh_makeshlibs:
	dh_makeshlibs -V --add-udeb="libjson-c4-udeb"

## json-c 0.15

=== debian/changelog ===
json-c (0.15-3~ubuntu1.22.04.2) jammy-security; urgency=medium

  * SECURITY UPDATE: Stack buffer overflow
    - debian/patches/CVE-2021-32292.patch: fix read past end of buffer
      in apps/json_parse.c.
    - CVE-2021-32292

 -- Leonidas Da Silva Barbosa <leo.barbosa@canonical.com>  Thu, 24 Aug 2023 12:56:26 -0300

json-c (0.15-3~ubuntu1.22.04.1) jammy; urgency=medium

  * SRU to Ubuntu 22.04.1 (LP: #1973270)

 -- Gianfranco Costamagna <locutusofborg@debian.org>  Fri, 13 May 2022 09:27:59 +0200

json-c (0.15-3) unstable; urgency=medium

  * Mark dev package as M-A: same (Closes: #1009805)
    - thanks Tomeu Vizoso for the hint.

 -- Gianfranco Costamagna <locutusofborg@debian.org>  Wed, 20 Apr 2022 09:02:05 +0200

json-c (0.15-2) unstable; urgency=low

  [Debian Janitor]
  * Set upstream metadata fields: Bug-Database, Repository, Repository-Browse.

  [Nicolas Mora]
  * d/patches make build reproductible (Closes: #966657)
  * d/control: Update standards version to 4.5.1 (no change)

 -- Nicolas Mora <babelouest@debian.org>  Wed, 03 Feb 2021 07:28:20 -0500

json-c (0.15-1) unstable; urgency=medium

  * New upstream release (Closes: #966366)
  * Update symbols file with versioned references (Closes: #963932)
  * Disable patch 608.patch, now applied upstream
  * d/rules: generate doxgen files with new config file doc/Doxyfile
  * debian/patches/0002-doxygen.patch
    - Set doxygen option FULL_PATH_NAMES to NO

 -- Nicolas Mora <babelouest@debian.org>  Wed, 29 Jul 2020 23:37:54 -0400

json-c (0.14+dfsg-1) unstable; urgency=medium

  [Gianfranco Costamagna]
  * Fix documentation generation (Closes: #962013)
  * debian/patches/608.patch:
    - Add patch to fix CVE-2020-12762 (Closes: #960326)

  [Nicolas Mora]
  * New upstream release 0.14.
  * Upload to unstable
  * New maintainer (Closes: #844452)
  * d/control: Rules-Requires-Root: no
  * Add d/gbp.conf
  * debian/patches/0002-doxygen.patch
    - Remove remote images in doxygen generated files
  * Update symbols file
  * Add autpkgtests
  * Clean lintian-overrides
  * debian/patches/0003-config-h.patch
    - Remove macro PACKAGE_NAME

 -- Nicolas Mora <babelouest@debian.org>  Thu, 23 Jul 2020 18:16:11 -0400

json-c (0.13.1+dfsg-9) unstable; urgency=medium

  * QA upload
  * Fix documentation generation (Closes: #962013)

 -- Gianfranco Costamagna <locutusofborg@debian.org>  Wed, 17 Jun 2020 09:28:38 +0200

json-c (0.13.1+dfsg-8) unstable; urgency=medium

  [ Leonidas S. Barbosa ]
  * SECURITY UPDATE: Integer overflows
    - debian/patches/CVE-2020-12762-*.patch: fix a series of
      integer overflows adding checks in linkhash.c, printbuf.c, test4.c
      test4.expected.
    - CVE-2020-12762

  [ Gianfranco Costamagna ]
  * QA upload
  * Import Ubuntu patch (Closes: #960326)

 -- Gianfranco Costamagna <locutusofborg@debian.org>  Tue, 16 Jun 2020 09:45:32 +0200

=== debian/control ===
--- 
+++ 
@@ -1,17 +1,18 @@
 Source: json-c
 Priority: optional
 Maintainer: Ubuntu Developers <ubuntu-devel-discuss@lists.ubuntu.com>
-XSBC-Original-Maintainer: Debian QA Group <packages@qa.debian.org>
-Build-Depends: debhelper-compat (= 12),
+XSBC-Original-Maintainer: Nicolas Mora <babelouest@debian.org>
+Build-Depends: debhelper-compat (= 13),
+               cmake,
                doxygen,
-               dh-exec
-Standards-Version: 4.5.0
+Standards-Version: 4.5.1
 Section: libs
 Homepage: https://github.com/json-c/json-c/wiki
 Vcs-Git: https://salsa.debian.org/debian/json-c.git
 Vcs-Browser: https://salsa.debian.org/debian/json-c
+Rules-Requires-Root: no
 
-Package: libjson-c4
+Package: libjson-c5
 Architecture: any
 Multi-Arch: same
 Pre-Depends: ${misc:Pre-Depends}
@@ -24,9 +25,9 @@
 
 Package: libjson-c-dev
 Section: libdevel
+Multi-Arch: same
 Architecture: any
-Multi-Arch: same
-Depends: libjson-c4 (= ${binary:Version}),
+Depends: libjson-c5 (= ${binary:Version}),
          ${misc:Depends}
 Description: JSON manipulation library - development files
  This library allows you to easily construct JSON objects in C,
@@ -49,7 +50,7 @@
  .
  The documentation for libjson-c is provided by this package.
 
-Package: libjson-c4-udeb
+Package: libjson-c5-udeb
 Section: debian-installer
 Package-Type: udeb
 Architecture: any
@@ -61,4 +62,4 @@
  output them as JSON formatted strings and parse JSON formatted
  strings back into the C representation of JSON objects.
  .
- This udeb package provides libjson-c4 for the Debian Installer.
+ This udeb package provides libjson-c5 for the Debian Installer.

## json-c 0.16

=== tests/CMakeLists.txt ===
cmake_minimum_required(VERSION 3.1)
add_executable(test1Formatted test1.c parse_flags.c parse_flags.h)
target_compile_definitions(test1Formatted PRIVATE TEST_FORMATTED=1)
target_link_libraries(test1Formatted PRIVATE ${PROJECT_NAME})

add_executable(test2Formatted test2.c parse_flags.c parse_flags.h)
target_compile_definitions(test2Formatted PRIVATE TEST_FORMATTED=1)
target_link_libraries(test2Formatted PRIVATE ${PROJECT_NAME})

# https://cmake.org/cmake/help/v3.0/command/add_test.html
# https://pabloariasal.github.io/2018/02/19/its-time-to-do-cmake-right/

include_directories(PUBLIC ${CMAKE_SOURCE_DIR})

set(ALL_TEST_NAMES
    test1
    test2
    test4
    testReplaceExisting
    test_cast
    test_charcase
    test_compare
    test_deep_copy
    test_double_serializer
    test_float
    test_int_add
    test_locale
    test_null
    test_parse
    test_parse_int64
    test_printbuf
    test_set_serializer
    test_set_value
    test_strerror
    test_util_file
    test_visit
    test_object_iterator)

if (NOT DISABLE_JSON_POINTER)
    set(ALL_TEST_NAMES ${ALL_TEST_NAMES} test_json_pointer)
endif()

foreach(TESTNAME ${ALL_TEST_NAMES})

add_executable(${TESTNAME} ${TESTNAME}.c)
if(${TESTNAME} STREQUAL test_strerror OR ${TESTNAME} STREQUAL test_util_file)
# For output consistency, we need _json_c_strerror() in some tests:
target_sources(${TESTNAME} PRIVATE ../strerror_override.c)
endif()
add_test(NAME ${TESTNAME} COMMAND ${PROJECT_SOURCE_DIR}/tests/${TESTNAME}.test)

# XXX using the non-target_ versions of these doesn't work :(
target_include_directories(
  ${TESTNAME}
  PUBLIC
    ${CMAKE_CURRENT_LIST_DIR}
  )
target_link_libraries(
  ${TESTNAME}
  PRIVATE
    ${PROJECT_NAME}
  )

endforeach(TESTNAME)

=== debian/changelog ===
json-c (0.16-2) unstable; urgency=medium

  * Update std-version to 4.6.1
  * d/copyright: Update copyright year
  * d/source: Add lintian-overrides due to false-positives in doc/html/

 -- Nicolas Mora <babelouest@debian.org>  Sun, 02 Oct 2022 19:26:06 -0400

json-c (0.16-1) unstable; urgency=medium

  * Update watch file for new location
  * Update std-version to 4.6.0
  * New upstream version 0.16
  * Refresh patch 0002-doxygen.patch and 0003-config-h.patch
  * Drop old patches 0004-reproducible-build.patch and 608.patch part of new upstream codebase
  * Refresh symbols
  * Update copyright file

 -- Gianfranco Costamagna <locutusofborg@debian.org>  Thu, 28 Apr 2022 11:26:15 +0200

=== debian/control ===
--- 
+++ 
@@ -1,11 +1,10 @@
 Source: json-c
 Priority: optional
-Maintainer: Ubuntu Developers <ubuntu-devel-discuss@lists.ubuntu.com>
-XSBC-Original-Maintainer: Nicolas Mora <babelouest@debian.org>
+Maintainer: Nicolas Mora <babelouest@debian.org>
 Build-Depends: debhelper-compat (= 13),
                cmake,
                doxygen,
-Standards-Version: 4.5.1
+Standards-Version: 4.6.1
 Section: libs
 Homepage: https://github.com/json-c/json-c/wiki
 Vcs-Git: https://salsa.debian.org/debian/json-c.git

## json-c 0.17

=== doc/CMakeLists.txt ===
# generate doxygen documentation for json-c API

find_package(Doxygen)

if (DOXYGEN_FOUND)

	configure_file(${CMAKE_CURRENT_SOURCE_DIR}/Doxyfile.in
	  ${CMAKE_CURRENT_BINARY_DIR}/Doxyfile)
	message(STATUS "Wrote ${CMAKE_CURRENT_BINARY_DIR}/Doxyfile")

	add_custom_target(doc
	COMMAND ${DOXYGEN_EXECUTABLE} ${CMAKE_CURRENT_BINARY_DIR}/Doxyfile)

else (DOXYGEN_FOUND)
	message("Warning: doxygen not found, the 'doc' target will not be included")
endif(DOXYGEN_FOUND)

=== debian/changelog ===
json-c (0.17-1) unstable; urgency=medium

  * New upstream version
  * Update std-version to 4.6.2
  * d/symbols: update symbols file
  * d/patches: remove patch 0001-CMakeLists-use-GNUInstallDirs.patch
    no longer required
  * d/patches: refresh patches 0003-config-h.patch and 0002-doxygen.patch
  * d/.gitlab-ci.yml: add gitlab ci script for salsa

 -- Nicolas Mora <babelouest@debian.org>  Tue, 15 Aug 2023 16:13:54 -0400

=== debian/control ===
--- 
+++ 
@@ -4,7 +4,7 @@
 Build-Depends: debhelper-compat (= 13),
                cmake,
                doxygen,
-Standards-Version: 4.6.1
+Standards-Version: 4.6.2
 Section: libs
 Homepage: https://github.com/json-c/json-c/wiki
 Vcs-Git: https://salsa.debian.org/debian/json-c.git

=== debian/watch ===
version=4
opts=uversionmangle=s/(\d+\.\d+(\.\d+)?)-\d+/$1/,\
dversionmangle=s/\+dfsg$//,repacksuffix=+dfsg \
https://github.com/json-c/json-c/tags .*/json-c-(\d.*)\.(?:tgz|tbz2|txz|tar\.(?:gz|bz2|xz))
# Nicolas Braud-Santoni <nicolas@braud-santoni.eu>  Mon, 30 Apr 2018

## json-c 0.17-1build1trisquel0

=== debian/changelog ===
json-c (0.17-1build1trisquel0) ecne; urgency=medium

  * Fetch and build as udeb dependency for debian-installer.

 -- Trisquel GNU/Linux developers <trisquel-devel@listas.trisquel.info>  Fri, 27 Sep 2024 20:04:00 +0000

json-c (0.17-1build1) noble; urgency=high

  * No change rebuild for 64-bit time_t and frame pointers.

 -- Julian Andres Klode <juliank@ubuntu.com>  Mon, 08 Apr 2024 18:00:48 +0200

=== debian/control ===
--- 
+++ 
@@ -1,6 +1,7 @@
 Source: json-c
 Priority: optional
-Maintainer: Nicolas Mora <babelouest@debian.org>
+Maintainer: Trisquel GNU/Linux developers <trisquel-devel@listas.trisquel.info>
+XSBC-Original-Maintainer: Nicolas Mora <babelouest@debian.org>
 Build-Depends: debhelper-compat (= 13),
                cmake,
                doxygen,

## json-c 0.18+ds

=== CMakeLists.txt ===
# CMake 3.9 was released in 2017/07
#  As of 2023, many versions of Linux, NetBSD and FreeBSD provide,
#   and many OpenWRT packages require, much newer CMake packages.
#  We're stopping before 3.10 because that version starts requiring
#   c++11, which isn't available on e.g HPUX.
cmake_minimum_required(VERSION 3.9...3.12)

# JSON-C library is C only project.
# PROJECT_VERSION{,_MAJOR,_MINOR,_PATCH} set by project():
project(json-c LANGUAGES C VERSION 0.18)

# set default build type if not specified by user
if(NOT CMAKE_BUILD_TYPE)
	set(CMAKE_BUILD_TYPE debug)
endif()

set(CMAKE_C_FLAGS_RELEASE   "${CMAKE_C_FLAGS_RELEASE} -O2")

include(CTest)

# Set some packaging variables.
set(CPACK_PACKAGE_NAME              "${PROJECT_NAME}")
set(CPACK_PACKAGE_VERSION_MAJOR     "${PROJECT_VERSION_MAJOR}")
set(CPACK_PACKAGE_VERSION_MINOR     "${PROJECT_VERSION_MINOR}")
set(CPACK_PACKAGE_VERSION_PATCH     "${PROJECT_VERSION_PATCH}")
set(JSON_C_BUGREPORT                "json-c@googlegroups.com")
set(CPACK_SOURCE_IGNORE_FILES
        ${PROJECT_SOURCE_DIR}/build
        ${PROJECT_SOURCE_DIR}/cmake-build-debug
        ${PROJECT_SOURCE_DIR}/pack
        ${PROJECT_SOURCE_DIR}/.idea
        ${PROJECT_SOURCE_DIR}/.DS_Store
        ${PROJECT_SOURCE_DIR}/.git
        ${PROJECT_SOURCE_DIR}/.vscode)

include(CheckSymbolExists)
include(CheckIncludeFile)
include(CheckIncludeFiles)
include(CheckCSourceCompiles)
include(CheckTypeSize)
include(CPack)
include(GNUInstallDirs)
include(CMakePackageConfigHelpers)

option(BUILD_SHARED_LIBS  "Default to building shared libraries" ON)
option(BUILD_STATIC_LIBS  "Default to building static libraries" ON)

if (BUILD_SHARED_LIBS)
    add_definitions(-D JSON_C_DLL)
endif()

# Generate a release merge and test it to verify the correctness of republishing the package.
ADD_CUSTOM_TARGET(distcheck
COMMAND make package_source
    COMMAND tar -xvf "${PROJECT_NAME}-${PROJECT_VERSION_MAJOR}.${PROJECT_VERSION_MINOR}.${PROJECT_VERSION_PATCH}-Source.tar.gz"
    COMMAND mkdir "${PROJECT_NAME}-${PROJECT_VERSION_MAJOR}.${PROJECT_VERSION_MINOR}.${PROJECT_VERSION_PATCH}-Source/build"
    COMMAND cmake "${PROJECT_NAME}-${PROJECT_VERSION_MAJOR}.${PROJECT_VERSION_MINOR}.${PROJECT_VERSION_PATCH}-Source/" -B"./${PROJECT_NAME}-${PROJECT_VERSION_MAJOR}.${PROJECT_VERSION_MINOR}.${PROJECT_VERSION_PATCH}-Source/build/"
    COMMAND make -C "${PROJECT_NAME}-${PROJECT_VERSION_MAJOR}.${PROJECT_VERSION_MINOR}.${PROJECT_VERSION_PATCH}-Source/build"
    COMMAND make test -C "${PROJECT_NAME}-${PROJECT_VERSION_MAJOR}.${PROJECT_VERSION_MINOR}.${PROJECT_VERSION_PATCH}-Source/build"
    COMMAND rm -rf "${PROJECT_NAME}-${PROJECT_VERSION_MAJOR}.${PROJECT_VERSION_MINOR}.${PROJECT_VERSION_PATCH}-Source"
)

# Enable or disable features. By default, all features are turned off.
option(DISABLE_BSYMBOLIC              "Avoid linking with -Bsymbolic-function."               OFF)
option(DISABLE_THREAD_LOCAL_STORAGE   "Disable using Thread-Local Storage (HAVE___THREAD)."   OFF)
option(DISABLE_WERROR                 "Avoid treating compiler warnings as fatal errors."     OFF)
option(ENABLE_RDRAND                  "Enable RDRAND Hardware RNG Hash Seed."                 OFF)
option(ENABLE_THREADING               "Enable partial threading support."                     OFF)
option(OVERRIDE_GET_RANDOM_SEED       "Override json_c_get_random_seed() with custom code."   OFF)
option(DISABLE_EXTRA_LIBS             "Avoid linking against extra libraries, such as libbsd." OFF)
option(DISABLE_JSON_POINTER           "Disable JSON pointer (RFC6901) and JSON patch support." OFF)
option(DISABLE_JSON_PATCH             "Disable JSON patch (RFC6902) support."                 OFF)
option(NEWLOCALE_NEEDS_FREELOCALE     "Work around newlocale bugs in old FreeBSD by calling freelocale"  OFF)
option(BUILD_APPS                     "Default to building apps" ON)


if (UNIX OR MINGW OR CYGWIN)
    list(APPEND CMAKE_REQUIRED_DEFINITIONS -D_GNU_SOURCE)
endif()

if (UNIX)
    list(APPEND CMAKE_REQUIRED_LIBRARIES   m)
endif()

if (MSVC)
    list(APPEND CMAKE_REQUIRED_DEFINITIONS /D_CRT_SECURE_NO_DEPRECATE)
    list(APPEND CMAKE_REQUIRED_FLAGS /wd4996)
endif()

if (NOT DISABLE_STATIC_FPIC)
    # Use '-fPIC'/'-fPIE' option.
    # This will allow other libraries to statically link in libjson-c.a
    # which in turn prevents crashes in downstream apps that may use
    # a different JSON library with identical symbol names.
    set(CMAKE_POSITION_INDEPENDENT_CODE ON)
endif()

check_include_file("fcntl.h"        HAVE_FCNTL_H)
check_include_file("inttypes.h"     HAVE_INTTYPES_H)
check_include_file(stdarg.h         HAVE_STDARG_H)
check_include_file(strings.h        HAVE_STRINGS_H)
check_include_file(string.h         HAVE_STRING_H)
check_include_file(syslog.h         HAVE_SYSLOG_H)


check_include_files("stdlib.h;stdarg.h;string.h;float.h" STDC_HEADERS)

check_include_file(unistd.h         HAVE_UNISTD_H)
check_include_file(sys/types.h      HAVE_SYS_TYPES_H)
check_include_file(sys/resource.h   HAVE_SYS_RESOURCE_H) # for getrusage

check_include_file("dlfcn.h"        HAVE_DLFCN_H)
check_include_file("endian.h"       HAVE_ENDIAN_H)
check_include_file("limits.h"       HAVE_LIMITS_H)
check_include_file("locale.h"       HAVE_LOCALE_H)
check_include_file("memory.h"       HAVE_MEMORY_H)

check_include_file(stdint.h         HAVE_STDINT_H)
check_include_file(stdlib.h         HAVE_STDLIB_H)
check_include_file(sys/cdefs.h      HAVE_SYS_CDEFS_H)
check_include_file(sys/param.h      HAVE_SYS_PARAM_H)
check_include_file(sys/random.h     HAVE_SYS_RANDOM_H)
check_include_file(sys/stat.h       HAVE_SYS_STAT_H)
check_include_file(xlocale.h        HAVE_XLOCALE_H)

# Set json-c specific vars to stamp into json_config.h
# in a way that hopefully won't conflict with other
# projects that use json-c.
if (HAVE_INTTYPES_H)
	set(JSON_C_HAVE_INTTYPES_H 1)
endif()
if (HAVE_STDINT_H)
	set(JSON_C_HAVE_STDINT_H 1)
endif()

check_symbol_exists(_isnan          "float.h" HAVE_DECL__ISNAN)
check_symbol_exists(_finite         "float.h" HAVE_DECL__FINITE)

if ((MSVC AND NOT (MSVC_VERSION LESS 1800)) OR MINGW OR CYGWIN OR UNIX)
    check_symbol_exists(INFINITY    "math.h" HAVE_DECL_INFINITY)
    check_symbol_exists(isinf       "math.h" HAVE_DECL_ISINF)
    check_symbol_exists(isnan       "math.h" HAVE_DECL_ISNAN)
    check_symbol_exists(nan         "math.h" HAVE_DECL_NAN)
endif()

check_symbol_exists(_doprnt         "stdio.h" HAVE_DOPRNT)
if (UNIX OR MINGW OR CYGWIN)
    check_symbol_exists(snprintf    "stdio.h" HAVE_SNPRINTF)
endif()
check_symbol_exists(vasprintf       "stdio.h" HAVE_VASPRINTF)
check_symbol_exists(vsnprintf       "stdio.h" HAVE_VSNPRINTF)
check_symbol_exists(vprintf         "stdio.h" HAVE_VPRINTF)

check_symbol_exists(arc4random      "stdlib.h" HAVE_ARC4RANDOM)
if (NOT HAVE_ARC4RANDOM AND DISABLE_EXTRA_LIBS STREQUAL "OFF")
    check_include_file(bsd/stdlib.h HAVE_BSD_STDLIB_H)
    if (HAVE_BSD_STDLIB_H)
		list(APPEND CMAKE_REQUIRED_LIBRARIES "bsd")
		unset(HAVE_ARC4RANDOM CACHE)
        check_symbol_exists(arc4random   "bsd/stdlib.h" HAVE_ARC4RANDOM)
        if (NOT HAVE_ARC4RANDOM)
			list(REMOVE_ITEM CMAKE_REQUIRED_LIBRARIES "bsd")
        endif()
    endif()
endif()

if (HAVE_FCNTL_H)
    check_symbol_exists(open        "fcntl.h" HAVE_OPEN)
endif()
if (HAVE_STDLIB_H)
    check_symbol_exists(realloc     "stdlib.h" HAVE_REALLOC)
endif()
if (HAVE_LOCALE_H)
    check_symbol_exists(setlocale   "locale.h" HAVE_SETLOCALE)
    check_symbol_exists(uselocale   "locale.h" HAVE_USELOCALE)
endif()

# uClibc *intentionally* crashes in duplocale(), at least as of:
# https://github.com/ffainelli/uClibc/blob/266bdc1/libc/misc/locale/locale.c#L1322
# So, if it looks like we're compiling for a system like that just disable
# locale handling entirely.
execute_process (COMMAND ${CMAKE_C_COMPILER} -dumpmachine ERROR_QUIET OUTPUT_VARIABLE CMAKE_GNU_C_MACHINE)

if (CMAKE_GNU_C_MACHINE MATCHES "uclibc")
	message(STATUS "Detected uClibc compiler, disabling locale handling")
	set(HAVE_SETLOCALE 0)
	set(HAVE_USELOCALE 0)
endif()

if (HAVE_STRINGS_H)
    check_symbol_exists(strcasecmp  "strings.h" HAVE_STRCASECMP)
    check_symbol_exists(strncasecmp "strings.h" HAVE_STRNCASECMP)
endif()
if (HAVE_STRING_H)
    check_symbol_exists(strdup      "string.h" HAVE_STRDUP)
    check_symbol_exists(strerror    "string.h" HAVE_STRERROR)
endif()
if (HAVE_SYSLOG_H)
    check_symbol_exists(vsyslog     "syslog.h" HAVE_VSYSLOG)
endif()
if (HAVE_SYS_RANDOM_H)
    check_symbol_exists(getrandom   "sys/random.h" HAVE_GETRANDOM)
endif()
if (HAVE_SYS_RESOURCE_H)
    check_symbol_exists(getrusage   "sys/resource.h" HAVE_GETRUSAGE)
endif()

check_symbol_exists(strtoll     "stdlib.h" HAVE_STRTOLL)
check_symbol_exists(strtoull    "stdlib.h" HAVE_STRTOULL)

set(json_c_strtoll "strtoll")
if (NOT HAVE_STRTOLL)
# Use _strtoi64 if strtoll is not available.
check_symbol_exists(_strtoi64 "stdlib.h" __have_strtoi64)
if (__have_strtoi64)
    #set(HAVE_STRTOLL 1)
    set(json_c_strtoll "_strtoi64")
endif()
endif()

set(json_c_strtoull "strtoull")
if (NOT HAVE_STRTOULL)
# Use _strtoui64 if strtoull is not available.
check_symbol_exists(_strtoui64 "stdlib.h" __have_strtoui64)
if (__have_strtoui64)
    #set(HAVE_STRTOULL 1)
    set(json_c_strtoull "_strtoui64")
endif()
endif()


check_type_size(int                 SIZEOF_INT)
check_type_size(int64_t             SIZEOF_INT64_T)
check_type_size(long                SIZEOF_LONG)
check_type_size("long long"         SIZEOF_LONG_LONG)
check_type_size("size_t"            SIZEOF_SIZE_T)
if (MSVC)
list(APPEND CMAKE_EXTRA_INCLUDE_FILES BaseTsd.h)
check_type_size("SSIZE_T"           SIZEOF_SSIZE_T)
else()
check_type_size("ssize_t"           SIZEOF_SSIZE_T)
endif()

check_c_source_compiles(
"
extern void json_object_get();
__asm__(\".section .gnu.json_object_get\\n\\t.ascii \\\"Please link against libjson-c instead of libjson\\\"\\n\\t.text\");
int main(int c, char *v) { return 0;}
"
HAS_GNU_WARNING_LONG)

check_c_source_compiles(
  "int main() { int i, x = 0; i = __sync_add_and_fetch(&x,1); return x; }"
  HAVE_ATOMIC_BUILTINS)

if (NOT DISABLE_THREAD_LOCAL_STORAGE)
  check_c_source_compiles(
    "__thread int x = 0; int main() { return 0; }"
    HAVE___THREAD)

  if (HAVE___THREAD)
      set(SPEC___THREAD __thread)
  elseif (MSVC)
      set(SPEC___THREAD __declspec(thread))
  endif()
endif()

# Hardware random number is not available on Windows? Says, config.h.win32. Best to preserve compatibility.
if (WIN32)
    set(ENABLE_RDRAND 0)
endif()

# Once we've done basic symbol/header searches let's add them in.
configure_file(${PROJECT_SOURCE_DIR}/cmake/config.h.in        ${PROJECT_BINARY_DIR}/config.h)
message(STATUS "Wrote ${PROJECT_BINARY_DIR}/config.h")
configure_file(${PROJECT_SOURCE_DIR}/cmake/json_config.h.in   ${PROJECT_BINARY_DIR}/json_config.h)
message(STATUS "Wrote ${PROJECT_BINARY_DIR}/json_config.h")

if (NOT DEFINED CMAKE_C_COMPILER_FRONTEND_VARIANT OR "${CMAKE_C_COMPILER_FRONTEND_VARIANT}" STREQUAL "")  # only available in cmake 3.14+
	if ("${CMAKE_C_COMPILER_ID}" STREQUAL "MSVC")
		set(CMAKE_C_COMPILER_FRONTEND_VARIANT "MSVC")
	elseif ("${CMAKE_C_COMPILER_ID}" STREQUAL "GNU")
		set(CMAKE_C_COMPILER_FRONTEND_VARIANT "GNU")
	elseif ("${CMAKE_C_COMPILER_ID}" STREQUAL "Clang")
		# Detect clang-cl.exe, it is Clang but with MSVC compatible command line arguments
		execute_process (COMMAND ${CMAKE_C_COMPILER} -? ERROR_QUIET OUTPUT_QUIET RESULT_VARIABLE _clang_result)
		if (_clang_result EQUAL 0)
			set(CMAKE_C_COMPILER_FRONTEND_VARIANT "MSVC")
		else()
			set(CMAKE_C_COMPILER_FRONTEND_VARIANT "GNU")
			message(STATUS, "clang result is NOT 0")
		endif()
	endif()
endif()

if ("${CMAKE_C_COMPILER_FRONTEND_VARIANT}" STREQUAL "GNU" OR "${CMAKE_C_COMPILER_FRONTEND_VARIANT}" STREQUAL "Clang")
    set(CMAKE_C_FLAGS           "${CMAKE_C_FLAGS} -ffunction-sections -fdata-sections")
	if ("${DISABLE_WERROR}" STREQUAL "OFF")
	    set(CMAKE_C_FLAGS           "${CMAKE_C_FLAGS} -Werror")
	endif()

=== tests/CMakeLists.txt ===
--- 
+++ 
@@ -1,4 +1,4 @@
-cmake_minimum_required(VERSION 3.1)
+cmake_minimum_required(VERSION 3.9)
 add_executable(test1Formatted test1.c parse_flags.c parse_flags.h)
 target_compile_definitions(test1Formatted PRIVATE TEST_FORMATTED=1)
 target_link_libraries(test1Formatted PRIVATE ${PROJECT_NAME})
@@ -24,6 +24,7 @@
     test_double_serializer
     test_float
     test_int_add
+    test_int_get
     test_locale
     test_null
     test_parse
@@ -38,15 +39,14 @@
 
 if (NOT DISABLE_JSON_POINTER)
     set(ALL_TEST_NAMES ${ALL_TEST_NAMES} test_json_pointer)
+    if (NOT DISABLE_JSON_PATCH)
+        set(ALL_TEST_NAMES ${ALL_TEST_NAMES} test_json_patch)
+    endif()
 endif()
 
 foreach(TESTNAME ${ALL_TEST_NAMES})
 
 add_executable(${TESTNAME} ${TESTNAME}.c)
-if(${TESTNAME} STREQUAL test_strerror OR ${TESTNAME} STREQUAL test_util_file)
-# For output consistency, we need _json_c_strerror() in some tests:
-target_sources(${TESTNAME} PRIVATE ../strerror_override.c)
-endif()
 add_test(NAME ${TESTNAME} COMMAND ${PROJECT_SOURCE_DIR}/tests/${TESTNAME}.test)
 
 # XXX using the non-target_ versions of these doesn't work :(

=== debian/changelog ===
json-c (0.18+ds-1.1) unstable; urgency=medium

  * Non-maintainer upload.
  * Enforce higher CMake policy version (Closes: #1113062)

 -- Timo Röhling <roehling@debian.org>  Sat, 18 Oct 2025 18:22:09 +0200

json-c (0.18+ds-1) unstable; urgency=medium

  * New upstream version
  * d/watch: Repack source to ignore doc/html prebuilt files
  * d/patches: Update 0002-doxygen.patch
  * d/control: Update standards version to 4.7.0
  * d/symbols: update symbols file
  * d/source/lintian-overrides: Remove lintian-overrides

 -- Nicolas Mora <babelouest@debian.org>  Thu, 19 Sep 2024 07:22:46 -0400

=== debian/control ===
--- 
+++ 
@@ -1,11 +1,10 @@
 Source: json-c
 Priority: optional
-Maintainer: Trisquel GNU/Linux developers <trisquel-devel@listas.trisquel.info>
-XSBC-Original-Maintainer: Nicolas Mora <babelouest@debian.org>
+Maintainer: Nicolas Mora <babelouest@debian.org>
 Build-Depends: debhelper-compat (= 13),
                cmake,
                doxygen,
-Standards-Version: 4.6.2
+Standards-Version: 4.7.0
 Section: libs
 Homepage: https://github.com/json-c/json-c/wiki
 Vcs-Git: https://salsa.debian.org/debian/json-c.git

=== debian/rules ===
#!/usr/bin/make -f
#export DH_VERBOSE=1

export USE_VALGRIND=0

DPKG_GENSYMBOLS_CHECK_LEVEL ?= 4

export DEB_BUILD_MAINT_OPTIONS = hardening=+all

include /usr/share/dpkg/architecture.mk

export DEB_HOST_MULTIARCH

%:
	dh $@ --buildsystem=cmake --builddirectory=build

override_dh_auto_configure:
	dh_auto_configure --buildsystem=cmake --builddirectory=build -- -DCMAKE_POLICY_VERSION_MINIMUM=3.10

override_dh_makeshlibs:
	dh_makeshlibs -V --add-udeb="libjson-c5-udeb"

override_dh_auto_build:
	cd build && $(MAKE) doc
	dh_auto_build --

=== debian/tests/control ===
Tests: unit-test
Depends: @, gcc, libc-dev, cmake

=== debian/watch ===
version=4
opts=\
repacksuffix=+ds,\
repack,compression=xz,\
uversionmangle=s/(\d+\.\d+(\.\d+)?)-\d+/$1/,\
dversionmangle=s/\+ds$// \
https://github.com/json-c/json-c/tags .*/json-c-(\d.*)\.(?:tgz|tbz2|txz|tar\.(?:gz|bz2|xz))
# Nicolas Braud-Santoni <nicolas@braud-santoni.eu>  Mon, 30 Apr 2018
